function love.load()

	love.graphics.setBackgroundColor( 255, 255, 255 )

	Fire = love.graphics.newImage( "textures/test.png" )
	Smoke = love.graphics.newImage( "textures/fire-graphic.png" )

	Smokey = love.graphics.newParticleSystem( Smoke, 124 )

	Smokey:setLinearAcceleration( 0, -15, 0, -20 )
	Smokey:setParticleLifetime( 4, 6 )
	Smokey:setSizes( 0.10, 0.25, 0.45, 0.65)
	Smokey:setSpeed( 10 , 15)
	Smokey:setDirection( 0 )
	Smokey:setColors( 0, 0, 0, 255, 50, 50, 50, 150 )

	rect = {

    	x = 400-64,
    	y = 300-64,
    	width = 128,
    	height = 128,

}

	--[[ ]]--
	slider = {}
	slider.active = {dragging = false}
	slider.boxOffset = 0
	slider.x = 50
	slider.y = 50
	slider.length = 100
	slider.boxW = 20
	slider.boxH = 10
	slider.boxX = slider.x - slider.boxW/2
	slider.boxY = slider.y - slider.boxH/2
	--[[ ]]--
	
end

function love.update(dt)
	Smokey:update( dt )
	
	--[[ ]]--
	local function clamp(val, low, up)
		return val > up and up or val < low and low or val
	end
	
	if slider.active.dragging then
		slider.boxOffset = love.mouse.getX() - slider.x
		slider.boxOffset = clamp(slider.boxOffset, 0, slider.length)
		
		--Changing the color through a ratio of the slider's length to the maximum value a color can be (255) then add it on.
		local ratio = 255 / slider.length
		local color = ratio * slider.boxOffset
		Smokey:setColors( 0 + color, 0, 0, 255, 50, 50, 50, 150 )
	end
	--[[ ]]--
	
end

function love.draw()

	love.graphics.setColor( 255, 255, 0, 0 )
	love.graphics.rectangle( "fill", 400-64, 300-64, 128, 128 )

	love.graphics.setColor( 255, 255, 255, 255 )
	love.graphics.draw( Fire, 462-128, 374-128, 0, 0.25, 0.25, 0, 0 )
	
	love.graphics.draw( Smokey, 400, 300 )

	--[[ ]]--
	love.graphics.setColor(0, 0, 0, 255)
	love.graphics.line(slider.x, slider.y, slider.x + slider.length, slider.y)
	love.graphics.setColor(50, 50, 50, 255)
	love.graphics.rectangle("fill", slider.boxX + slider.boxOffset, slider.boxY, slider.boxW, slider.boxH)
	--[[ ]]--
	
end

function love.mousepressed( x, y, button )

	if button == "l" then

		print( "Left button Clicked at" )
		print( "X: ".. x )
		print( "Y: ".. y )

		if( x >= rect.x and x <= rect.x + rect.width
		and y >= rect.y and y<= rect.y + rect.height ) then

			print( "Emit Smoke" )

			Smokey:emit( 5 )

		end
		
		--[[ ]]--
		local function boxCollision(x1, y1, w1, h1, x2, y2, w2, h2)
			return y1 < y2 + h2 and y2 < y1 + h1 and x1 < x2 + w2 and x2 < x1 + w1
		end
		
		if boxCollision(x, y, 0, 0, slider.boxX + slider.boxOffset, slider.boxY, slider.boxW, slider.boxH) then
			slider.active.dragging = true
		end
		--[[ ]]--
		
	end

end

--[[ ]]--
function love.mousereleased(x, y, button)
	if button == "l" then
		if slider.active.dragging then
			slider.active.dragging = false
		end
	end
end
--[[ ]]--